;
; "RED BLOCKS" 113 byte DOS intro by bitl/7dUMP
; Entry for Hugi Size Coding Competition #30 (2023)
; For compilation use Turbo  Assembler 2.02
; tasm /m2 redblock.asm
; tlink /t redblock.obj
;
; RUN ONLINE:
; http://twt86.co/?c=xC9DsRZRU1D32%2BL5sBPNELgQEP7DivN19fqyE19eWwPedQn33uVAMuAD%2BEOA%2BxR%2BAvfeU1a4AAJXi8vR6Sv5aclAASv5i%2FOLy%2FOqgcdAASv7TnXzisPQ4ALDS1%2F%2BzHXYZltKdbeD7HL79ORgSHWqzSA%3D

NUM_BLOCKS=20 ; number and size (only even numbers)
SIZE_BLOCK=20 ; max size of block
.model tiny
.code
.386
org 0100h
start:
les bp, [bx] ; nearly VGA-segment (ES=9fffh)

;;; push values to stack
inc bx
mov cl, NUM_BLOCKS+2
@r:
push cx   ; start size
push bx   ; start increment (1 or -1)
push ax   ; start position (0)
neg bx
loop @r

;;; set vga-mode and palette
mov al, 13h
@pal:
  int 10h
  mov ax, 1010h
  inc bl
  mov dh, bl
jnz @pal

;;; MAIN LOOP
@mainloop:
cli
mov dl, NUM_BLOCKS-1
@blocks_draw:
pop di  ; position
pop si  ; increment
pop bx  ; size

;;;increment size
add bx, si
jnz @sk1
;;; if size=0 make random position
    neg si ; and revers increment
    in ax, 40h
    xor ah, al
    add di, ax
    inc bx
@sk1:

;;; if size>max revers increment
cmp bl, SIZE_BLOCK
jle @sk2
;    mov bl, SIZE_BLOCK-1
    neg si
@sk2:

push bx ; update size
push si ; update increment

;;; draw block (first black)
mov ax, 0200h
@redraw:
push di ; update position
mov cx, bx
shr cx, 1  ; centering
sub di, cx
imul cx, cx, 320
sub di, cx
mov si, bx
@block:    ; draw loop
mov cx, bx
rep stosb
add di, 320
sub di, bx
dec si
jnz @block

;;; set color value
mov al, bl
shl al, 1 ; color = size*2+size
add al, bl
dec bx

pop di      ; restor di for redraw
dec ah
jnz @redraw ; goto to draw red block

pop ebx     ; add sp, 4

dec dx
jnz @blocks_draw

sub sp, 6*(NUM_BLOCKS-1)
sti

hlt  ;;; pause

;;; wait for ESC
in al, 60h
dec ax
jnz @mainloop

;;; set text-mode and exit
;mov al, 3
;int 10h
int 20h
end start

UUE-ENCODED BINARY COM-FILE FOR DOS:
MQ"]#L1914U#WV^+YL!/-$+@0$/[#BO-U]?JR$U]>6P/>=0GWWN5`,N`#^$.`
M^Q1^`O?>4U:X``)7B\O1Z2OY:<E``2OYB_.+R_.J@<=``2O[3G7SBL/0X`+#
72U_^S'789EM*=;>#['+[].1@2'6JS2``
